#!/usr/bin/perl -w

($oifile, $proddir, $srcroot, $uilcmd, $ogcmd) = @ARGV;
print "-->Making langs from $oifile to $proddir -->  using $uilcmd and $ogcmd\n";

# makelangs - make the "langs" subdirectory for a given product.
# working directory has no assumpumtions
# stdin is directed to Phrases/langs.tx, the list of languages

my $outCode;

print  "] mkdir $proddir\n";
system "mkdir $proddir > /dev/null";
system "echo ---Starting new session > langs.output";

open(F, "$srcroot/Phrases/langs.tx");
open(L, ">$proddir/listing");
while ($line = <F>)
{
    chop($line);
    if (!$line)
    {
		last;
    }

    # langcode = like "fr" or "es"
    # phrasefile = like "frl.ph" or "jal.phb"
    # engname = like "Spanish"
    # forname = like "tEspan&ntilde;ol" if textual or "gjaname.gif" if graphic
    ($langcode, $phrasefile, $engname, $forname, $i18encode) = split /\t/,$line;
    
	print "-> Starting with $langcode=$engname=$forname\n";
    # come up with a decent name to show.  
    # if it starts with "t" or "r", a translation or reference english,
    if ($forname =~ /^r.*/)
    {
		# reference english
		# add a line to the list printed out for the user
		print L "en = en_* = English\n";
		
		# do the resources, no phrase file
		print  "  ] $ogcmd $oifile >> langs.output\n";
		system "$ogcmd $oifile >>langs.output 2>>langs.output";
		
		if ($? != 0)
		{
			print "  -- ERROR [" . ($? >> 8) . "]\n";
			next;
		}
		print  "  ] $uilcmd -o $proddir/en.uid >>langs.output\n";
		system "$uilcmd -o $proddir/en.uid >>langs.output 2>>langs.output";
		if ($? != 0)
		{
			print "  -- ERROR [" . ($? >> 8) . "]\n";
			next;
		}
    }
    elsif ($forname =~ /^t.*/)
    {
		# a western european translation
		$decentname = substr($forname, 1);
	
		# wait a minute, fix the html entities.  Feel free to add more.
		$decentname =~ s/\&ecirc\;/\xEA/;
		$decentname =~ s/\&ntilde\;/\xF1/;
		$decentname =~ s/\&ccedil\;/\xE7/;
	
		# add a line to the list printed out for the user
		print L "$langcode = $i18encode = $decentname\n";
		
		# do the resources
		print  "  ] $ogcmd $oifile $srcroot/Phrases/$phrasefile >> langs.output\n";
		system "$ogcmd $oifile $srcroot/Phrases/$phrasefile >>langs.output 2>>langs.output";
		if ($? != 0)
		{
			print "  -- ERROR [" . ($? >> 8) . "]\n";
			next;
		}
		
		print  "  ] $uilcmd -o $proddir/$langcode.uid >> langs.output\n";
		system "$uilcmd -o $proddir/$langcode.uid >>langs.output 2>>langs.output";
		if ($? != 0)
		{
			print "  -- ERROR [" . ($? >> 8) . "]\n";
			next;
		}
    }
    else
    {
		# case g = the foreign name needs a graphic to say it right
		# in other words, uil will barf on it.  So skip it.  ru & ja.
	
		# case o - numbered english.  Not for general consumption.
		print  "  ! this type of language is not supported: $phrasefile\n";
    }
    print "->done with $langcode=$engname=$forname\n";
  }
close(L);
close(F);
